/*
** Author: Dimitris Diochnos
** email : diochnos AT gmail DOT com
**
** File Name: mighty_classes.cpp
**
** Date Started : 20 April 2006.
** Date Finished: 28 April 2006.
**
** internals_mc (version 1.0)
** Date Started :  6 July 2007.
** Date Finished: 11 July 2007.
**
** internals_mc (version 1.1)
** Date Started : 12 July 2007.
** Date Finished: 20 July 2007.
**
**
** Tab space: 3
**
**
** The "MonteCarlo" file.
**
*/


#include <iostream>
#include "sec_skills_mighty.h"
#include "mighty_classes.h"
//#include "math_toolbox.h"

MonteCarlo::MonteCarlo(HERO_PTR hero, DEC_MAK_PTR dMaker)
{
	myHero = hero;
	myDecisionMaker = dMaker;
}

void	MonteCarlo::run (MT_PTR toolbox)
{
	unsigned int 		i, slot;
	unsigned char 		hero_name, hero_class, choice;
	long unsigned int episodes_requested;
	//char 					temp[32];
	SKILL_OFFER_PTR 	offer;

	hero_class = myHero->get_hero_class ();
	hero_name = myHero->get_hero_name ();

	toolbox->initializeOccurrences (); 	// Not necessary on single hero.
	episodes_requested = toolbox->getNumberOfEpisodes ();

	for (i = 0; i < episodes_requested; i++) {
		// Generate an episode.
		myHero->myInit (hero_class, hero_name);
		myDecisionMaker->LoopInitializer ();

		if ((episodes_requested >= 100) && (i % ((int) episodes_requested / 100)) == 0) {
			std::cout << "\rWork done   : " << (int) i*100 / episodes_requested << " %";
			std::cout.flush ();
		}

		//std::cout << "\n\nNew Episode\n" << std::endl;

		while ( !myHero->get_fully_upgraded() ) {
			// Hero can upgrade an existing skill or acquire a new one.
			myHero->increment_level ();

			//std::cout << "Current Level: " << (int) myHero->get_hero_level () << std::endl;
			offer = myHero->get_skill_offer ();
			//std::cout << " left     : " << get_skill_name_12 (offer->left) << std::endl;
			//std::cout << " right    : " << get_skill_name_12 (offer->right) << std::endl;
			choice = myDecisionMaker->applyPolicy (offer);
			myHero->addSkill ( choice );

			delete offer;

			//if (( myHero->get_hero_level () == 6 ) && (i==4) )
			//	std::cin >> temp;
		}

		for (slot = 0; slot < SKILL_SLOTS; slot++)
			toolbox->incrementOccurrences( myHero->get_skill_from_slot (slot) );

	}

	std::cout << "\r                            \r";
	std::cout.flush ();
}
