/*
** Author: Dimitris Diochnos
** email : diochnos AT gmail DOT com
**
** File Name: mighty_classes.cpp
**
** Date Started : 20 April 2006.
** Date Finished: 28 April 2006.
**
** Revision (internals_mc)
** Date Started :  6 July 2007.
** Date Finished: 11 July 2007.
**
** Tab space: 3
**
**
** The header file for mathematical toolbox.
**
*/

#ifndef __MATH_TOOLBOX_H__
#define __MATH_TOOLBOX_H__

#include <ctime>
#include "mighty_classes.h"

/*****************************************************************************/

enum Printing_Methods { DEPRECATED = 0, NEAT, FANCY };
#define MAX_PRINTING_METHOD FANCY

/*****************************************************************************/

class MathToolbox {
	public:
								MathToolbox ();
								~MathToolbox ();
		unsigned char		getPrintingMethod () const;
		bool					setPrintingMethod (const unsigned char);
		void					printStatistics (HERO_PTR, const clock_t, const clock_t);
		bool 					incrementOccurrences (const unsigned char);
		long unsigned int getOccurrences (const unsigned char) const;
		void 					setNumberOfEpisodes (const long unsigned int);
		long unsigned int getNumberOfEpisodes () const;
		void 					setSeed (const unsigned int);
		unsigned int 		getSeed () const;
		void 					initializeOccurrences ();
		void 					setProbabilities ();


	private:
		void				printStatisticsDeprecated (HERO_PTR, const clock_t, const clock_t);
		void				printStatisticsNeat (HERO_PTR, const clock_t, const clock_t);
		void				printStatisticsFancy (HERO_PTR, const clock_t, const clock_t);
		// Private variables.
		unsigned char			printing_method;
		long unsigned int 	occurrences [DIFF_SEC_SKILLS];
		long unsigned int 	episodes;
		double 					probabilities [DIFF_SEC_SKILLS];
		unsigned int 			seed;
};

typedef MathToolbox MT;
typedef MT * MT_PTR;

/*****************************************************************************/

#endif
