/*
** Author: Dimitris Diochnos
** email : diochnos AT gmail DOT com
**
** File Name: mighty_classes.cpp
**
** Date Started : 20 April 2006.
** Date Finished: 28 April 2006.
**
** internals_mc (version 1.0)
** Date Started :  6 July 2007.
** Date Finished: 11 July 2007.
**
** internals_mc (version 1.1)
** Date Started : 12 July 2007.
** Date Finished: 20 July 2007.
**
**
** Tab space: 3
**
**
** Definitions for the 'Hero' class.
**
*/

#include <iostream>
#include "mighty_classes.h"

/*****************************************************************************/

char * Alchemists_Names []    = { "FAFNER", "IONA", "NEELA", "PIQUEDRAM", "JOSEPHINE", "RISSA", "THANE", "TOROSAR" };
char * Barbarians_Names []    = { "CRAG_HACK", "GRETCHIN", "GURNISSON", "JABARKAS", "KRELLION", "SHIVA", "TYRAXOR", "YOG" };
char * Beastmasters_Names []  = { "ALKIN", "BROGHILD", "BRON", "DRAKON", "GERWULF", "KORBAC", "TAZAR", "WYSTAN" };
char * Death_Knights_Names [] = { "CHARNA", "CLAVIUS", "GALTHRAN", "ISRA", "MOANDOR", "TAMIKA", "STRAKER", "VOKIAL" };
char * Demoniacs_Names []     = { "RASHKA", "CALH", "FIONA", "IGNATIUS", "MARIUS", "NYMUS", "PYRE", "OCTAVIA" };
char * Knights_Names []       = { "EDRIC", "ORRIN", "SYLVIA", "LORD_HAART", "VALESKA", "CHRISTIAN", "SORSHA", "TYRIS", "SIR_MULLICH" };
char * Overlords_Names []     = { "AJIT", "ARLACH", "DACE", "DAMACON", "GUNNAR", "LORELEI", "SHAKTI", "SYNCA" };
char * Planeswalkers_Names [] = { "ERDAMON", "FIUR", "IGNISSA", "KALT", "LACUS", "MONERE", "PASIS", "THUNAR" };
char * Rangers_Names []       = { "CLANCY", "IVOR", "JENOVA", "KYRRE", "MEPHALA", "RYLAND", "THORGRIM", "UFRETIN", "GELU" };

/*****************************************************************************/

unsigned char Magic_Schools []         = { AIR_MAGIC, EARTH_MAGIC, FIRE_MAGIC, WATER_MAGIC };

/*****************************************************************************/

// Magic Schools:                             A                     E     F                                                        W
unsigned char Alchemist_secSkill []    = { 0, 4, 5,  8, 4, 6, 3, 3, 3, 4, 1, 2, 4,  3, 10,  6, 2, 4, 3,  0,  6, 4, 5, 3, 4, 3,  4, 2, 6 };
unsigned char Barbarian_secSkill []    = { 0, 3, 7,  6, 8, 8, 1, 2, 3, 2, 2, 1, 1,  5,  4,  7, 3, 3, 2,  0, 10, 8, 6, 1, 8, 1,  8, 0, 2 };
unsigned char Beastmaster_secSkill []  = { 0, 1, 7, 10, 8, 7, 1, 1, 3, 1, 0, 6, 1,  5,  4,  8, 2, 2, 8,  0,  5, 8, 5, 1, 7, 1,  6, 2, 2 };
unsigned char Death_secSkill []        = { 0, 2, 5,  5, 5, 7, 2, 4, 4, 0, 1, 0, 5,  0,  4,  5, 1, 4, 8, 10,  7, 4, 5, 2, 4, 4,  5, 3, 6 };
unsigned char Demoniac_secSkill []     = { 0, 2, 6,  7, 5, 7, 4, 3, 3, 3, 4, 2, 2,  3,  4, 10, 2, 2, 4,  0,  8, 4, 6, 2, 5, 3,  6, 1, 4 };
unsigned char Knight_secSkill []       = { 0, 3, 5,  5, 5, 8, 4, 2, 2, 6, 1, 2, 1, 10,  4,  5, 3, 2, 8,  0,  7, 4, 5, 1, 4, 1,  7, 4, 3 };
unsigned char Overlord_secSkill []     = { 0, 1, 6,  6, 8, 7, 3, 2, 3, 4, 2, 1, 1,  8,  4,  8, 1, 3, 4,  0,  8, 5, 6, 1, 5, 2, 10, 0, 3 };
unsigned char Planeswalker_secSkill [] = { 0, 2, 8,  5, 8, 8, 2, 2, 3, 3, 3, 1, 1,  3,  8,  8, 2, 3, 5,  0,  9, 6, 2, 1, 6, 1,  8, 2, 2 };
unsigned char Ranger_secSkill []       = { 0, 1, 8,  8, 6, 4, 4, 2, 3, 2, 0, 3, 2,  6,  4,  5, 6, 3, 3,  0,  5, 7, 9, 1, 7, 2,  5, 3, 3 };

/*****************************************************************************/

Hero::Hero (const unsigned char hero_class, const unsigned char hero_name)
{
	myInit( hero_class, hero_name );
}

/*****************************************************************************/

Hero::~Hero () {}

/*****************************************************************************/

void 	Hero::myInit (const unsigned char hero_class, const unsigned char hero_name)
{	
	int 	temp, j;

	//std::cout<<"--------------"<<std::endl;
	//std::cout<<"New Hero"<<std::endl;
	//std::cout<<"--------------"<<std::endl;

	classification = hero_class;
	name = hero_name;
	magic_schools = 0;
	has_wisdom = false;
	level = 1;
	initial_skills = 2;
	last_magic_level_offer = 0;
	last_wisdom_level_offer = 0;
	max_number_of_magic_schools = (unsigned char) 4;
	//skill_chances = (unsigned char *) NULL;


	for (temp = 1; temp < 8; temp++) {
		skills [temp] = (unsigned char) NULL_SKILL;
		expertize [temp] = (unsigned char) 0;
	}



	switch (classification) {
		/************\
		* ALCHEMISTS *
		\************/
		case ALCHEMIST:
			skill_chances = (unsigned char *) Alchemist_secSkill;
			switch (name) {
				case FAFNER:
					skills [0] = SCHOLAR;
					skills [1] = RESISTANCE;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case IONA:
					skills [0] = SCHOLAR;
					skills [1] = INTELLIGENCE;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case NEELA:
					skills [0] = SCHOLAR;
					skills [1] = ARMORER;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case PIQUEDRAM:
					skills [0] = MYSTICISM;
					skills [1] = SCOUTING;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case JOSEPHINE:
					skills [0] = MYSTICISM;
					skills [1] = SORCERY;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case RISSA:
					skills [0] = MYSTICISM;
					skills [1] = OFFENSE;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case THANE:
					skills [0] = SCHOLAR;
					expertize [0] = ADVANCED;
					initial_skills = 1;
					break;

				case TOROSAR:
					skills [0] = MYSTICISM;
					skills [1] = TACTICS;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				default:
					break;
			}
			break;


		/************\
		* BARBARIANS *
		\************/
		case BARBARIAN:
			skill_chances = (unsigned char *) Barbarian_secSkill;
			max_number_of_magic_schools = (unsigned char) 3; 	// Can't get WATER_MAGIC.
			switch (name) {
				case CRAG_HACK:
					skills [0] = OFFENSE;
					expertize [0] = ADVANCED;
					initial_skills = 1;
					break;

				case GRETCHIN:
					skills [0] = OFFENSE;
					skills [1] = PATHFINDING;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case GURNISSON:
					skills [0] = OFFENSE;
					skills [1] = ARTILLERY;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case JABARKAS:
					skills [0] = OFFENSE;
					skills [1] = ARCHERY;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case KRELLION:
					skills [0] = OFFENSE;
					skills [1] = RESISTANCE;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case SHIVA:
					skills [0] = OFFENSE;
					skills [1] = SCOUTING;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case TYRAXOR:
					skills [0] = OFFENSE;
					skills [1] = TACTICS;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case YOG:
					skills [0] = OFFENSE;
					skills [1] = BALLISTICS;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				default:
					break;
			}
			break;


		/**************\
		* BEASTMASTERS *
		\**************/
		case BEASTMASTER:
			skill_chances = (unsigned char *) Beastmaster_secSkill;
			max_number_of_magic_schools = (unsigned char) 3; 	// Can't get FIRE_MAGIC.
			switch (name) {
				case ALKIN:
					skills [0] = ARMORER;
					skills [1] = OFFENSE;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case BROGHILD:
					skills [0] = ARMORER;
					skills [1] = SCOUTING;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case BRON:
					skills [0] = ARMORER;
					skills [1] = RESISTANCE;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case DRAKON:
					skills [0] = ARMORER;
					skills [1] = LEADERSHIP;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case GERWULF:
					skills [0] = ARMORER;
					skills [1] = ARTILLERY;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case KORBAC:
					skills [0] = ARMORER;
					skills [1] = PATHFINDING;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case TAZAR:
					skills [0] = ARMORER;
					expertize [0] = ADVANCED;
					initial_skills = 1;
					break;

				case WYSTAN:
					skills [0] = ARMORER;
					skills [1] = ARCHERY;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				default:
					break;
			}
			break;


		/***************\
		* DEATH KNIGHTS *
		\***************/
		case DEATH_KNIGHT:
			skill_chances = (unsigned char *) Death_secSkill;
			switch (name) {
				case CHARNA:
					skills [0] = NECROMANCY;
					skills [1] = TACTICS;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case CLAVIUS:
					skills [0] = NECROMANCY;
					skills [1] = OFFENSE;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case GALTHRAN:
					skills [0] = NECROMANCY;
					skills [1] = ARMORER;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case ISRA:
					skills [0] = NECROMANCY;
					expertize [0] = ADVANCED;
					initial_skills = 1;
					break;

				case MOANDOR:
					skills [0] = NECROMANCY;
					skills [1] = LEARNING;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case TAMIKA:
					skills [0] = NECROMANCY;
					skills [1] = OFFENSE;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case STRAKER:
					skills [0] = NECROMANCY;
					skills [1] = RESISTANCE;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case VOKIAL:
					skills [0] = NECROMANCY;
					skills [1] = ARTILLERY;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				default:
					break;
			}
			break;


		/***********\
		* DEMONIACS *
		\***********/
		case DEMONIAC:
			skill_chances = (unsigned char *) Demoniac_secSkill;
			switch (name) {
				case RASHKA:
					skills [0] = SCHOLAR;
					skills [1] = WISDOM;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					has_wisdom = true;
					break;

				case CALH:
					skills [0] = ARCHERY;
					skills [1] = SCOUTING;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case FIONA:
					skills [0] = SCOUTING;
					expertize [0] = ADVANCED;
					initial_skills = 1;
					break;

				case IGNATIUS:
					skills [0] = TACTICS;
					skills [1] = RESISTANCE;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case MARIUS:
					skills [0] = ARMORER;
					expertize [0] = ADVANCED;
					initial_skills = 1;
					break;

				case NYMUS:
					skills [0] = OFFENSE;
					expertize [0] = ADVANCED;
					initial_skills = 1;
					break;

				case PYRE:
					skills [0] = LOGISTICS;
					skills [1] = ARTILLERY;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case OCTAVIA:
					skills [0] = SCHOLAR;
					skills [1] = OFFENSE;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				default:
					break;
			}
			break;


		/*********\
		* KNIGHTS *
		\*********/
		case KNIGHT:
			skill_chances = (unsigned char *) Knight_secSkill;
			switch (name) {
				case EDRIC:
					skills [0] = LEADERSHIP;
					skills [1] = ARMORER;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case ORRIN:
					skills [0] = LEADERSHIP;
					skills [1] = ARCHERY;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case SYLVIA:
					skills [0] = LEADERSHIP;
					skills [1] = NAVIGATION;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case LORD_HAART:
					skills [0] = LEADERSHIP;
					skills [1] = ESTATES;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case VALESKA:
					skills [0] = LEADERSHIP;
					skills [1] = ARCHERY;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case CHRISTIAN:
					skills [0] = LEADERSHIP;
					skills [1] = ARTILLERY;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case SORSHA:
					skills [0] = LEADERSHIP;
					skills [1] = OFFENSE;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case TYRIS:
					skills [0] = LEADERSHIP;
					skills [1] = TACTICS;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case SIR_MULLICH:
					skills [0] = LEADERSHIP;
					expertize [0] = ADVANCED;
					initial_skills = 1;
					break;

				default:
					break;
			}
			break;


		/***********\
		* OVERLORDS *
		\***********/
		case OVERLORD:
			skill_chances = (unsigned char *) Overlord_secSkill;
			max_number_of_magic_schools = (unsigned char) 3; 	// Can't get WATER_MAGIC.
			switch (name) {
				case AJIT:
					skills [0] = LEADERSHIP;
					skills [1] = RESISTANCE;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case ARLACH:
					skills [0] = OFFENSE;
					skills [1] = ARTILLERY;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case DACE:
					skills [0] = TACTICS;
					skills [1] = OFFENSE;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case DAMACON:
					skills [0] = OFFENSE;
					expertize [0] = ADVANCED;
					initial_skills = 1;
					break;

				case GUNNAR:
					skills [0] = TACTICS;
					skills [1] = LOGISTICS;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case LORELEI:
					skills [0] = LEADERSHIP;
					skills [1] = SCOUTING;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case SHAKTI:
					skills [0] = OFFENSE;
					skills [1] = TACTICS;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case SYNCA:
					skills [0] = LEADERSHIP;
					skills [1] = SCHOLAR;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				default:
					break;
			}
			break;


		/***************\
		* PLANESWALKERS *
		\***************/
		case PLANESWALKER:
			skill_chances = (unsigned char *) Planeswalker_secSkill;
			switch (name) {
				case ERDAMON:
					skills [0] = TACTICS;
					skills [1] = ESTATES;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case FIUR:
					skills [0] = OFFENSE;
					expertize [0] = ADVANCED;
					initial_skills = 1;
					break;

				case IGNISSA:
					skills [0] = OFFENSE;
					skills [1] = ARTILLERY;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case KALT:
					skills [0] = TACTICS;
					skills [1] = LEARNING;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case LACUS:
					skills [0] = TACTICS;
					expertize [0] = ADVANCED;
					initial_skills = 1;
					break;

				case MONERE:
					skills [0] = OFFENSE;
					skills [1] = LOGISTICS;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case PASIS:
					skills [0] = OFFENSE;
					skills [1] = ARTILLERY;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case THUNAR:
					skills [0] = TACTICS;
					skills [1] = ESTATES;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				default:
					break;
			}
			break;


		/*********\
		* RANGERS *
		\*********/
		case RANGER:
			skill_chances = (unsigned char *) Ranger_secSkill;
			max_number_of_magic_schools = (unsigned char) 3; 	// Can't get FIRE_MAGIC.
			switch (name) {
				case CLANCY:
					skills [0] = RESISTANCE;
					skills [1] = PATHFINDING;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case IVOR:
					skills [0] = ARCHERY;
					skills [1] = OFFENSE;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case JENOVA:
					skills [0] = ARCHERY;
					expertize [0] = ADVANCED;
					initial_skills = 1;
					break;

				case KYRRE:
					skills [0] = ARCHERY;
					skills [1] = LOGISTICS;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case MEPHALA:
					skills [0] = LEADERSHIP;
					skills [1] = ARMORER;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case RYLAND:
					skills [0] = LEADERSHIP;
					skills [1] = DIPLOMACY;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case THORGRIM:
					skills [0] = RESISTANCE;
					expertize [0] = ADVANCED;
					initial_skills = 1;
					break;

				case UFRETIN:
					skills [0] = RESISTANCE;
					skills [1] = LUCK;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				case GELU:
					skills [0] = LEADERSHIP;
					skills [1] = ARCHERY;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					break;

				default:
					break;
			}
			break;

		default:
			break;
	}

	// This should stay after switch above in order to receive correct value.
	free_slot = initial_skills;

	// Initialize available skills array.	
	for (j = 0; j < DIFF_SEC_SKILLS; j++) {
		if ( (skill_chances [j] == 0) )
			available_skills [j] = false;
		else
			available_skills [j] = true;
	}
	available_skills [ skills [0] ] = false;
	available_skills [ skills [1] ] = false;

	// Initialize mapping table.
	for (j = 0; j < DIFF_SEC_SKILLS; j++)
		mapping_skills [j] = SKILL_SLOTS;	// Out of range by default.
	mapping_skills [ skills [0] ] = 0; 	// Every hero starts with at least one skill. No need to check for exception.
	if (skills [1] != NULL_SKILL)
		mapping_skills [ skills [1] ] = 1;
}

/*****************************************************************************/

unsigned char 	Hero::get_magic_schools () const 	{ return 	magic_schools; }

/*****************************************************************************/

unsigned char 	Hero::get_max_number_of_magic_schools () const 	{ return 	max_number_of_magic_schools; }

/*****************************************************************************/

bool 				Hero::get_has_wisdom () const 	{ return 	has_wisdom; }

/*****************************************************************************/

bool 				Hero::get_fully_upgraded () const
{
	unsigned char i;

	if (free_slot < SKILL_SLOTS)
		return false;	// For easy cases, return fast!

	for (i = 0; i < SKILL_SLOTS; i++) {
		if (expertize[i] != EXPERT)
			return false;
	}

	return true;
}

/*****************************************************************************/

unsigned char 	Hero::get_hero_level () const 	{ return 	level; }

/*****************************************************************************/

unsigned char 	Hero::get_last_magic_level_offer () const 	{ return 	last_magic_level_offer; }

/*****************************************************************************/

unsigned char 	Hero::get_last_wisdom_level_offer () const 	{ return 	last_wisdom_level_offer; }

/*****************************************************************************/

unsigned char 	Hero::get_hero_class () const 	{ return 	classification; }

/*****************************************************************************/

unsigned char 	Hero::get_hero_name () const 	{ return 	name; }

/*****************************************************************************/

unsigned char 	Hero::get_skill_from_slot (const unsigned char slot) const
{
	if (/*(slot >= 0) &&*/ (slot < 8))
		return 	skills[slot];
	else
		return 	NULL_SKILL;
}

/*****************************************************************************/

unsigned char 	Hero::get_skill_slot (const unsigned char skill) const
{
	return 	mapping_skills[skill];
}

/*****************************************************************************/

unsigned char * Hero::get_skill_chances () const
{
	unsigned char * temp = new unsigned char [DIFF_SEC_SKILLS];

	for (int i = 0; i < DIFF_SEC_SKILLS; i++)
		temp [i] = skill_chances [i];

	return temp;
}

/*****************************************************************************/

unsigned char		Hero::get_initial_skills () const
{
	return	initial_skills;
}

/*****************************************************************************/

void 				Hero::addSkill (const unsigned char new_skill)
{
	int slot;

	//std::cout << " selection: " << get_skill_name_12 (new_skill) << std::endl;

	if (new_skill == NULL_SKILL)
		std::cerr << std::endl << "addSkill error! [1]" << std::endl;

	slot = mapping_skills[new_skill];
	if (slot < SKILL_SLOTS) {
		expertize[slot]++;
		return;
	}

	if (free_slot >= SKILL_SLOTS) {
		std::cerr << std::endl << "Problem in addSkill!" << std::endl;
		return;
	}

	mapping_skills [new_skill] = free_slot;
	skills[free_slot] = new_skill;
	expertize[free_slot] = BASIC;
	free_slot++;

	if ( new_skill == WISDOM )
		has_wisdom = true;
	if ( is_magic_school(new_skill) )
		magic_schools++;
	available_skills [ new_skill ] = false;
}

/*****************************************************************************/

// New skills are offered according to our "theoretical" understanding on Skill-Advancing.
// i.e.: every 6 levels we have a WISDOM offer (either as a new skill or as an upgrade).
//       every 4 levels we have a MAGIC School offer (either as a new skill or as an upgrade).
SKILL_OFFER_PTR 	Hero::get_skill_offer ()
{
	SKILL_OFFER_PTR 	offer;
	unsigned char 		i, list_with_skills_for_upgrade[SKILL_SLOTS], size, weight, magic_weight, upgrade_weight;
	unsigned char		wisdom_for_upgrade, magic_for_upgrade[4], magic_size;
	bool 					wisdom_exception;

	offer = new SKILL_OFFER;
	size = 0;
	upgrade_weight = 0;
	// Note that by setting the pointer to 'SKILL_SLOTS', this is OUT OF BOUNDS. :)
	wisdom_for_upgrade = SKILL_SLOTS;
	magic_for_upgrade[0] = NULL_SKILL;
	magic_for_upgrade[1] = NULL_SKILL;
	magic_for_upgrade[2] = NULL_SKILL;
	magic_for_upgrade[3] = NULL_SKILL;
	magic_size = 0;
	// Check which skills you can upgrade.
	for (i = 0; i < SKILL_SLOTS; i++) {
		if ( skills[i] == NULL_SKILL )
			break; 	// Everything has been checked.
		if ( expertize[i] != EXPERT ) {// This skill can be upgraded.
			list_with_skills_for_upgrade[size++] = skills[i]; 	// Get skill name.
			upgrade_weight += skill_chances[ skills[i] ];
			if ( skills[i] == WISDOM )
				wisdom_for_upgrade = i; 	// Store pointer for WISDOM if WISDOM can be upgraded.
			if ( is_magic_school(skills[i]) )
				magic_for_upgrade[magic_size++] = skills [i]; 	// Store MAGIC Schools that can be upgraded.
		}
	}

	if ( upgrade_weight == 0 ) {
		// Hero has all skills at EXPERT level. Check if all slots are occupied.
		if (i == SKILL_SLOTS) {
			// All slots are occupied and at EXPERT level.
			// Nothing can be offered.
			offer->left = NULL_SKILL;
			offer->right = NULL_SKILL;

			return offer;
		}
		else {
			// Hero will be presented with TWO NEW skills.

			// Calculate total weight for available skills.
			weight = 0;
			for (i = 0; i < DIFF_SEC_SKILLS; i++) {
				if ( available_skills[i] )
					weight += skill_chances[i];
			}

			if ( get_has_wisdom () ) {
				// Hero already has WISDOM. No need to check for WISDOM exception (since it is at EXPERT level).
				if ( get_magic_schools () == get_max_number_of_magic_schools () ) {
					// Hero already has "ALL" ;) MAGIC schools. No need for MAGIC School exception (since "ALL" are at EXPERT level).

					// Set left choice and make necessary weight-arrangements.
					offer->left = Roll_Dice_for_new_skill (weight); 	// Roll dice for left offer.
					available_skills[offer->left] = false;
					weight -= skill_chances[offer->left];
					offer->right = Roll_Dice_for_new_skill (weight); 	// Roll dice for right offer.
					// Rectify some things and return offer.
					available_skills[offer->left] = true;

					// No need to check if WISDOM or a MAGIC School was offered.
					// Hero already has them ALL at EXPERT level.
					return offer;
				}
				else {
					// Hero has WISDOM at EXPERT level and < (MAX_NUMBER_OF) MAGIC Schools.
					// In case it has at least one MAGIC School then this (these) is (are) at EXPERT level.

					if ( (get_hero_level () - get_last_magic_level_offer ()) >= DEFAULT_MAGIC_SCHOOL_LEVEL ) {
						// We have a MAGIC School exception.
						magic_weight = 0;
//for (i=0;i<8;i++){std::cout << get_skill_name_12(skills[i]) <<std::endl;}
						if ( available_skills[AIR_MAGIC] ){
							magic_weight += skill_chances[AIR_MAGIC];
						}
						if ( available_skills[EARTH_MAGIC] ){
							magic_weight += skill_chances[EARTH_MAGIC];
						}
						if ( available_skills[FIRE_MAGIC] ){
							magic_weight += skill_chances[FIRE_MAGIC];
						}
						if ( available_skills[WATER_MAGIC] ){
							magic_weight += skill_chances[WATER_MAGIC];
						}
//						std::cout << "Magic schools: " << (int) magic_schools << " of " << (int) get_max_number_of_magic_schools () << std::endl;
						offer->left = Roll_Dice_for_new_magic_skill (magic_weight); 	// Roll dice for MAGIC offer.
						available_skills[offer->left] = false;
						weight -= skill_chances[offer->left];
						offer->right = Roll_Dice_for_new_skill (weight); 	// Roll dice for right offer.
						// Rectify some things and return offer.
						available_skills[offer->left] = true;
						last_magic_level_offer = get_hero_level (); 	// Set variable for MAGIC exception.

						return offer;
					}
					else {
						// No need for MAGIC School exception. But you have to check in the end.
						// Set left choice and make necessary weight-arrangements.
						offer->left = Roll_Dice_for_new_skill (weight); 	// Roll dice for left offer.
						available_skills[offer->left] = false;
						weight -= skill_chances[offer->left];
						offer->right = Roll_Dice_for_new_skill (weight); 	// Roll dice for right offer.
						// Rectify some things and return offer.
						available_skills[offer->left] = true;
						if ( is_magic_school(offer->left) || is_magic_school(offer->right) ) {
							// A MAGIC School was offered by chance.
							last_magic_level_offer = get_hero_level (); 	// Set variable for MAGIC exception.
						}

						return offer;
					}
				}
			}
			else {
				// Hero does NOT have WISDOM. Possible exception for this purpose.

				if ( (get_hero_level () - get_last_wisdom_level_offer ()) >= DEFAULT_WISDOM_LEVEL ) {
					// We have WISDOM exception at this level.
					offer->left = WISDOM;
					available_skills[WISDOM] = false;
					weight -= skill_chances[WISDOM];
					if ( get_magic_schools () == get_max_number_of_magic_schools () ) {
						// Hero already has ALL MAGIC Schools that he could attain (ALL at EXPERT level).
						offer->right = Roll_Dice_for_new_skill (weight); 	// Roll dice for right offer.
						// Rectify some things and return offer.
						available_skills[WISDOM] = true;
						last_wisdom_level_offer = get_hero_level ();

						return offer;
					}
					else {
						if ( (get_hero_level () - get_last_magic_level_offer ()) >= DEFAULT_MAGIC_SCHOOL_LEVEL ) {
							// We have a MAGIC School exception.
							magic_weight = 0;
							if ( available_skills[AIR_MAGIC] )
								magic_weight += skill_chances[AIR_MAGIC];
							if ( available_skills[EARTH_MAGIC] )
								magic_weight += skill_chances[EARTH_MAGIC];
							if ( available_skills[FIRE_MAGIC] )
								magic_weight += skill_chances[FIRE_MAGIC];
							if ( available_skills[WATER_MAGIC] )
								magic_weight += skill_chances[WATER_MAGIC];
							offer->right = Roll_Dice_for_new_magic_skill (magic_weight); 	// Roll dice for MAGIC offer.
							// Rectify some things and return offer.
							available_skills[WISDOM] = true;
							last_magic_level_offer = get_hero_level (); 	// Set variable for MAGIC exception.

							return offer;
						}
						else {
							// No need for MAGIC School exception. But you have to check in the end.
							offer->right = Roll_Dice_for_new_skill (weight); 	// Roll dice for right offer.
							// Rectify some things and return offer.
							available_skills[WISDOM] = true;
							if ( is_magic_school(offer->right) ) {
								// A MAGIC School was offered by chance.
								last_magic_level_offer = get_hero_level (); 	// Set variable for MAGIC exception.
							}

							return offer;
						}
					}
				}
				else {
					// No WISDOM exception. However, WISDOM may be offered due to chance.
					if ( get_magic_schools () == get_max_number_of_magic_schools () ) {
						// Hero already has "ALL" ;) MAGIC schools. No need for MAGIC School exception (since "ALL" are at EXPERT level).

						// Set left choice and make necessary weight-arrangements.
						offer->left = Roll_Dice_for_new_skill (weight); 	// Roll dice for left offer.
						available_skills[offer->left] = false;
						weight -= skill_chances[offer->left];
						offer->right = Roll_Dice_for_new_skill (weight); 	// Roll dice for right offer.
						// Rectify some things and return offer.
						available_skills[offer->left] = true;

						if ( (offer->left == WISDOM) || (offer->right == WISDOM) ) {
							// WISDOM was offered by chance.
							last_wisdom_level_offer = get_hero_level ();
						}

						return offer;
					}
					else {
						// Hero does NOT have WISDOM and has < (MAX_NUMBER_OF) MAGIC Schools.
						// In case it has at least one MAGIC School then this (these) is (are) at EXPERT level.

						if ( (get_hero_level () - get_last_magic_level_offer ()) >= DEFAULT_MAGIC_SCHOOL_LEVEL ) {
							// We have a MAGIC School exception.
							magic_weight = 0;
							if ( available_skills[AIR_MAGIC] )
								magic_weight += skill_chances[AIR_MAGIC];
							if ( available_skills[EARTH_MAGIC] )
								magic_weight += skill_chances[EARTH_MAGIC];
							if ( available_skills[FIRE_MAGIC] )
								magic_weight += skill_chances[FIRE_MAGIC];
							if ( available_skills[WATER_MAGIC] )
								magic_weight += skill_chances[WATER_MAGIC];
							offer->left = Roll_Dice_for_new_magic_skill (magic_weight); 	// Roll dice for MAGIC offer.
							available_skills[offer->left] = false;
							weight -= skill_chances[offer->left];
							offer->right = Roll_Dice_for_new_skill (weight); 	// Roll dice for right offer.
							// Rectify some things and return offer.
							available_skills[offer->left] = true;
							last_magic_level_offer = get_hero_level (); 	// Set variable for MAGIC exception.
							if ( offer->right == WISDOM )
								last_wisdom_level_offer = get_hero_level (); 	// Set variable for WISDOM exception (offered by chance).

							return offer;
						}
						else {
							// No need for MAGIC School exception. But you have to check in the end.
							offer->left = Roll_Dice_for_new_skill (weight); 	// Roll dice for left offer.
							available_skills[offer->left] = false;
							weight -= skill_chances[offer->left];
							offer->right = Roll_Dice_for_new_skill (weight); 	// Roll dice for right offer.
							// Rectify some things and return offer.
							available_skills[offer->left] = true;
							if ( (offer->left == WISDOM) || (offer->right == WISDOM) ) {
								// WISDOM was offered by chance.
								last_wisdom_level_offer = get_hero_level (); 	// Set variable for WISDOM exception (offered by chance).
							}
							if ( is_magic_school(offer->left) || is_magic_school(offer->right) ) {
								// A MAGIC School was offered by chance.
								last_magic_level_offer = get_hero_level (); 	// Set variable for MAGIC exception (offered by chance).
							}

							return offer;
						}
					}
				}
			}
		}
	}
	else {
		// Hero can upgrade AT LEAST ONE skill. The usual way I suppose ...
		/*
		** First set left offer (skill to upgrade).
		*/
		wisdom_exception = false;
		if ( ( (get_hero_level () - get_last_wisdom_level_offer ()) >= DEFAULT_WISDOM_LEVEL ) && (wisdom_for_upgrade < SKILL_SLOTS) ){
			// Hero has WISDOM not at expert level and in this level we have a WISDOM exception.
			offer->left = WISDOM;
			last_wisdom_level_offer = get_hero_level (); 	// Set variable for WISDOM exception.
			wisdom_exception = true;
		}
		else if ( ( (get_hero_level () - get_last_magic_level_offer ()) >= DEFAULT_MAGIC_SCHOOL_LEVEL ) && (magic_size > 0) ) {
			// Hero has AT LEAST ONE MAGIC School that can be upgraded and we have a MAGIC School exception at the moment.
			offer->left = Roll_Dice_for_magic_skill_upgrade (magic_for_upgrade, magic_size);
			last_magic_level_offer = get_hero_level (); 		// Set variable for MAGIC School exception.
		}
		else {
			// Left offer is decided at random.
			offer->left = Roll_Dice_for_skill_upgrade (list_with_skills_for_upgrade, size, upgrade_weight);
			if ( offer->left == WISDOM )
				last_wisdom_level_offer = get_hero_level (); 	// Set variable for WISDOM exception if necessary.
			if ( is_magic_school(offer->left) )
				last_magic_level_offer = get_hero_level (); 		// Set variable for MAGIC School exception if necessary.
		}


		/*
		** Set right offer (brand new skill ONLY IF last slot is empty).
		*/
		if (skills[SKILL_SLOTS - 1] == NULL_SKILL) {
			if ( ( (get_hero_level () - get_last_wisdom_level_offer ()) >= DEFAULT_WISDOM_LEVEL ) && (!get_has_wisdom ()) ){
				// We have a WISDOM exception and hero does not possess WISDOM. Therefore, this is the new skill.
				offer->right = WISDOM;
				last_wisdom_level_offer = get_hero_level ();
			}
			else if ( ( (get_hero_level () - get_last_magic_level_offer ()) >= DEFAULT_MAGIC_SCHOOL_LEVEL ) && 
						(magic_size == 0) && (get_magic_schools () < get_max_number_of_magic_schools ()) ) {
				// This level has MAGIC School exception. All MAGIC Schools that hero possesses are at EXPERT level
				// and at least ONE more MAGIC School is available.
				magic_weight = 0;
				if ( available_skills[AIR_MAGIC] )
					magic_weight += skill_chances[AIR_MAGIC];
				if ( available_skills[EARTH_MAGIC] )
					magic_weight += skill_chances[EARTH_MAGIC];
				if ( available_skills[FIRE_MAGIC] )
					magic_weight += skill_chances[FIRE_MAGIC];
				if ( available_skills[WATER_MAGIC] )
					magic_weight += skill_chances[WATER_MAGIC];
				offer->right = Roll_Dice_for_new_magic_skill (magic_weight); 	// Roll dice for MAGIC offer.
				last_magic_level_offer = get_hero_level ();
			}
			else {
				// Right offer should be decided at random.

				// Calculate total weight for available skills.
				weight = 0;
				for (i = 0; i < DIFF_SEC_SKILLS; i++) {
					if ( available_skills[i] )
						weight += skill_chances[i];
				}

				offer->right = Roll_Dice_for_new_skill (weight); 	// Roll dice for right offer.
				if ( (offer->right == WISDOM) ) {
					// WISDOM was offered by chance.
					last_wisdom_level_offer = get_hero_level (); 	// Set variable for WISDOM exception (offered by chance).
				}
				if ( is_magic_school(offer->right) ) {
					// A MAGIC School was offered by chance.
					last_magic_level_offer = get_hero_level (); 	// Set variable for MAGIC exception (offered by chance).
				}
			}
		}
		else if (size > 1) {
			// Hero can not acquire more skills.
			// There are more than 1 skills able to be upgraded.
			if ( wisdom_exception && ( (get_hero_level () - get_last_magic_level_offer ()) >= DEFAULT_MAGIC_SCHOOL_LEVEL ) && (magic_size > 0) ) {
				// All slots are occupied and we have WISDOM and MAGIC School exception at the same time.
				// Both WISDOM and at least one MAGIC School can be upgraded.
				// Therefore, a MAGIC School should be offered at the right side.
				offer->right = Roll_Dice_for_magic_skill_upgrade (magic_for_upgrade, magic_size);
				last_magic_level_offer = get_hero_level ();
			}
			else {
				for (i = 0; i < size; i++) {
					if (list_with_skills_for_upgrade[i] == offer->left)
						break;
				}
				for (; i < size - 1; i++)
					list_with_skills_for_upgrade[i] = list_with_skills_for_upgrade[i+1];
				size--;
				upgrade_weight -= skill_chances [offer->left];
				offer->right = Roll_Dice_for_skill_upgrade (list_with_skills_for_upgrade, size, upgrade_weight);
				if ( offer->right == WISDOM )
					last_wisdom_level_offer = get_hero_level (); 	// Set variable for WISDOM exception if necessary.
				if ( is_magic_school(offer->right) )
					last_magic_level_offer = get_hero_level (); 		// Set variable for MAGIC School exception if necessary.
			}
		}
		else {
			// Only 1 skill was available for upgrade and all other slots
			// are occupied by skills at EXPERT level.
			offer->right = NULL_SKILL;
		}

		return offer;
	}
}

/*****************************************************************************/

unsigned char 		Hero::Roll_Dice_for_new_skill (const unsigned char weight) const
{
	unsigned char rnd_number, temp_weight, i;

	rnd_number = ((unsigned char) (rand () % weight)) + ((unsigned char) 1); 	// Roll dice for new offer.
	temp_weight = (unsigned char) 0;
	for (i = 0; i < DIFF_SEC_SKILLS; i++) {
		if ( available_skills[i] ) {
			temp_weight += skill_chances[i];
			if ( temp_weight >= rnd_number )
				break; // 'i' is the skill that will be offered.
		}
	}

	if (i < DIFF_SEC_SKILLS)
		return i;
	else {
		std::cerr << "Problem rolling dice! [1]" << std::endl;
		return NULL_SKILL;
	}
}

/*****************************************************************************/

unsigned char 		Hero::Roll_Dice_for_new_magic_skill (const unsigned char weight) const
{
	unsigned char rnd_number, temp_weight;

//std::cout << (int) weight << std::endl;
	rnd_number = ((unsigned char) (rand () % weight)) + ((unsigned char) 1); 	// Roll dice for new MAGIC offer.
	temp_weight = (unsigned char) 0;
	if ( available_skills[AIR_MAGIC] )
		temp_weight += skill_chances[AIR_MAGIC];
	if ( temp_weight >= rnd_number )
		return AIR_MAGIC;
	if ( available_skills[EARTH_MAGIC] )
		temp_weight += skill_chances[EARTH_MAGIC];
	if ( temp_weight >= rnd_number )
		return EARTH_MAGIC;

	if ( available_skills[FIRE_MAGIC] )
		temp_weight += skill_chances[FIRE_MAGIC];
	if ( temp_weight >= rnd_number )
		return FIRE_MAGIC;

	if ( available_skills[WATER_MAGIC] )
		temp_weight += skill_chances[WATER_MAGIC];
	if ( temp_weight >= rnd_number )
		return WATER_MAGIC;

	std::cerr << "Problem rolling dice! [2]" << std::endl;

	return NULL_SKILL;
}

/*****************************************************************************/

unsigned char 		Hero::Roll_Dice_for_magic_skill_upgrade (unsigned char magic_for_upgrade[4], const unsigned char size) const
{
	unsigned char 	i, weight, temp_weight, rnd_number;

	if ( (size == 0) || (size > 4) ) {
		std::cerr << "Problem rolling dice! [3]" << std::endl;
		return NULL_SKILL;
	}

	weight = 0;
	for (i = 0; i < size; i++)
		weight += skill_chances[ magic_for_upgrade[i] ];
	rnd_number = ((unsigned char) (rand () % weight)) + ((unsigned char) 1); 	// Roll dice for MAGIC (upgrade) offer.
	temp_weight = (unsigned char) 0;
	for (i = 0; i < size; i++) {
		temp_weight += skill_chances[ magic_for_upgrade[i] ];
		if (temp_weight >= rnd_number)
			return magic_for_upgrade[i];
	}

	std::cerr << "Problem rolling dice! [4]" << std::endl;

	return NULL_SKILL;
}

/*****************************************************************************/

unsigned char 		Hero::Roll_Dice_for_skill_upgrade (
	unsigned char skills_for_upgrade[SKILL_SLOTS], 
	const unsigned char size,
	const unsigned char weight
	) const
{
	unsigned char 	i, temp_weight, rnd_number;

	rnd_number = ((unsigned char) (rand () % weight)) + ((unsigned char) 1);
	temp_weight = (unsigned char) 0;
	for (i = 0; i < size; i++) {
		temp_weight += skill_chances[ skills_for_upgrade[i] ];
		if (temp_weight >= rnd_number)
			return skills_for_upgrade[i];
	}

	std::cerr << "Problem rolling dice! [5]" << std::endl;

	return NULL_SKILL;
}

/*****************************************************************************/

void 				Hero::increment_level () { level++; }

/*****************************************************************************/

bool 				Hero::is_magic_school (const unsigned char skill) const
{
	return 	((skill == AIR_MAGIC) || (skill == EARTH_MAGIC) || (skill == FIRE_MAGIC) || (skill == WATER_MAGIC)) ? true : false;
}

/*****************************************************************************/

void 			Hero::print_Name () const
{
	unsigned int 	i;

	switch(classification) {
		case ALCHEMIST:
			std::cout << Alchemists_Names [name] << std::endl;
			for (i = 0; i < strlen (Alchemists_Names [name]); i++)
				std::cout << "~";
			std::cout << std::endl;
			break;

		case BARBARIAN:
			std::cout << Barbarians_Names [name] << std::endl;
			for (i = 0; i < strlen (Barbarians_Names [name]); i++)
				std::cout << "~";
			std::cout << std::endl;
			break;

		case BEASTMASTER:
			std::cout << Beastmasters_Names [name] << std::endl;
			for (i = 0; i < strlen (Beastmasters_Names [name]); i++)
				std::cout << "~";
			std::cout << std::endl;
			break;

		case DEATH_KNIGHT:
			std::cout << Death_Knights_Names [name] << std::endl;
			for (i = 0; i < strlen (Death_Knights_Names [name]); i++)
				std::cout << "~";
			std::cout << std::endl;
			break;

		case DEMONIAC:
			std::cout << Demoniacs_Names [name] << std::endl;
			for (i = 0; i < strlen (Demoniacs_Names [name]); i++)
				std::cout << "~";
			std::cout << std::endl;
			break;

		case KNIGHT:
			std::cout << Knights_Names [name] << std::endl;
			for (i = 0; i < strlen (Knights_Names [name]); i++)
				std::cout << "~";
			std::cout << std::endl;
			break;

		case OVERLORD:
			std::cout << Overlords_Names [name] << std::endl;
			for (i = 0; i < strlen (Overlords_Names [name]); i++)
				std::cout << "~";
			std::cout << std::endl;
			break;

		case PLANESWALKER:
			std::cout << Planeswalkers_Names [name] << std::endl;
			for (i = 0; i < strlen (Planeswalkers_Names [name]); i++)
				std::cout << "~";
			std::cout << std::endl;
			break;

		case RANGER:
			std::cout << Rangers_Names [name] << std::endl;
			for (i = 0; i < strlen (Rangers_Names [name]); i++)
				std::cout << "~";
			std::cout << std::endl;
			break;

		default:
			std::cout << "Are you nuts? You should not be here!" << std::endl;
			break;
	}
}

/*****************************************************************************/

/*
** DETERMINISTIC COMPUTATION FOR ANSA POLICY.
** CODE NEEDS TO BE RE-CHECKED BEFORE RE-USE
** SINCE available_skills IS NOW A private member
** OF HERO CLASS.
*/
double * 				Hero::ANSA_policy ()
{
	unsigned char 		i;
	unsigned char 		slot;
	bool * 				available_skills;
	unsigned char * 	skills_so_far = new unsigned char [SKILL_SLOTS];
	unsigned char 		total_remaining_weight;
	double 				prob_so_far;
	double * 			probabilities = new double [DIFF_SEC_SKILLS];

	// Initialize probability variables to ZERO.
	for (i = 0; i < DIFF_SEC_SKILLS; i++)
		probabilities [i] = (double) 0.0;
	prob_so_far = (double) 1.0;
	
	// Initialize available skills array.
	available_skills = new bool [DIFF_SEC_SKILLS];
	for (i = 0; i < DIFF_SEC_SKILLS; i++) {
		if ( (skill_chances [i] == 0) )
			available_skills [i] = false;
		else
			available_skills [i] = true;
	}
	available_skills [ skills [0] ] = false;
	available_skills [ skills [1] ] = false;

	// Create a duplicate of hero's original skills and count initial remaining total weight.
	total_remaining_weight = TOTAL_CHANCES;
	for (slot = 0; slot < SKILL_SLOTS; slot++) {
		skills_so_far [slot] = skills [slot];
		total_remaining_weight -= skill_chances [ skills [slot] ];
	}

	/*
	** Implement Depth-First search.
	*/
	depth_first_search (initial_skills, available_skills, skills_so_far, get_magic_schools (), get_has_wisdom (), prob_so_far, total_remaining_weight, probabilities);

	delete [] skills_so_far;
	delete [] available_skills;

	return 	probabilities;
}

/*****************************************************************************/

// Similarly as above, you might have to re-check source code.
void 				Hero::depth_first_search (const unsigned char slot, bool * available_skills, unsigned char * skills_so_far, const unsigned char magic_schools, bool wisdom, const double prob_so_far, const unsigned char remaining_weight, double * probabilities)
{
	register unsigned long int temp;
	register unsigned char 		pointer;
	double 							new_prob_so_far, current_prob;

	if (slot < SKILL_SLOTS - 1) {
		bool * 						next_slot_available_skills = new bool [DIFF_SEC_SKILLS];
		register unsigned char 	i;

		// Initialize next slot's available skills to a duplicate of currently available choices.
		for (i = 0; i < DIFF_SEC_SKILLS; i++)
			next_slot_available_skills [i] = available_skills [i];

		if ( (initial_skills == 2) && (slot == DEFAULT_WISDOM_LEVEL) && (!wisdom) ) {
			// ONLY available choice is WISDOM, therefore probability is 1 for this skill.
			skills_so_far [slot] = WISDOM;
			next_slot_available_skills [WISDOM] = false;
			// Since prob(WISDOM) = 1, then all I have to do is pass the same argument on prob_so_far.
			depth_first_search ((unsigned char) slot + 1, next_slot_available_skills, skills_so_far, magic_schools, true, prob_so_far, remaining_weight - skill_chances [WISDOM], probabilities);
			skills_so_far [slot] = (unsigned char) NULL_SKILL;
		}
		else if ( (initial_skills == 1) && (slot == DEFAULT_WISDOM_LEVEL - 1) && (!wisdom) ) {
			// ONLY available choice is WISDOM, therefore probability is 1 for this skill.
			skills_so_far [slot] = WISDOM;
			next_slot_available_skills [WISDOM] = false;
			// Since prob(WISDOM) = 1, then all I have to do is pass the same argument on prob_so_far.
			depth_first_search ((unsigned char) slot + 1, next_slot_available_skills, skills_so_far, magic_schools, true, prob_so_far, remaining_weight - skill_chances [WISDOM], probabilities);
			skills_so_far [slot] = (unsigned char) NULL_SKILL;
		}
		else if ( (initial_skills == 2) && (slot == DEFAULT_MAGIC_SCHOOL_LEVEL) && (magic_schools == 0) ) {
			/*
			** Hero must acquire a MAGIC SCHOOL, so let him follow (ONLY) each one of the "magical" paths. :P
			*/
			temp = (unsigned long int) skill_chances [AIR_MAGIC] + skill_chances [EARTH_MAGIC] + skill_chances [FIRE_MAGIC] + skill_chances [WATER_MAGIC];
				
			for (pointer = 0; pointer < 4; pointer++) {
				skills_so_far [slot] = Magic_Schools [pointer];
				next_slot_available_skills [ Magic_Schools [pointer] ] = false;
				// Chance is equal to: weight(current_magic_school) / SUM ( weight(Magic_Schools) ).
				current_prob = (double) ((double) skill_chances [ Magic_Schools [pointer] ]) / ((double) temp);
				new_prob_so_far = prob_so_far * current_prob;
				depth_first_search ((unsigned char) slot + 1, next_slot_available_skills, skills_so_far, 1, wisdom, new_prob_so_far, remaining_weight - skill_chances [ Magic_Schools [pointer] ], probabilities);
				skills_so_far [slot] = (unsigned char) NULL_SKILL;
				next_slot_available_skills [ Magic_Schools [pointer] ] = true;
			}
		}
		else if ( (initial_skills == 1) && (slot == DEFAULT_MAGIC_SCHOOL_LEVEL - 1) && (magic_schools == 0) ) {
			/*
			** Hero must acquire a MAGIC SCHOOL, so let him follow (ONLY) each one of the "magical" paths. :P
			*/
			temp = (unsigned long int) skill_chances [AIR_MAGIC] + skill_chances [EARTH_MAGIC] + skill_chances [FIRE_MAGIC] + skill_chances [WATER_MAGIC];
				
			for (pointer = 0; pointer < 4; pointer++) {
				skills_so_far [slot] = Magic_Schools [pointer];
				next_slot_available_skills [ Magic_Schools [pointer] ] = false;
				// Chance is equal to: weight(current_magic_school) / SUM ( weight(Magic_Schools) ).
				current_prob = (double) ((double) skill_chances [ Magic_Schools [pointer] ]) / ((double) temp);
				new_prob_so_far = prob_so_far * current_prob;
				depth_first_search ((unsigned char) slot + 1, next_slot_available_skills, skills_so_far, 1, wisdom, new_prob_so_far, remaining_weight - skill_chances [ Magic_Schools [pointer] ], probabilities);
				skills_so_far [slot] = (unsigned char) NULL_SKILL;
				next_slot_available_skills [ Magic_Schools [pointer] ] = true;
			}
		}
		else {
			// Hero can acquire ANY of the available skills.
			for (pointer = 1; pointer < DIFF_SEC_SKILLS; pointer++) {
				if (slot == initial_skills)
					std::cerr << "Part of computation: " << (int) pointer << "/" << (int) DIFF_SEC_SKILLS - 1 << "." << std::endl;

				if (available_skills [pointer]) {
					// use skill for this slot.
					skills_so_far [slot] = pointer;
					next_slot_available_skills [pointer] = false;
					current_prob = (double) ((double) skill_chances [ pointer ]) / ((double) remaining_weight);
					new_prob_so_far = prob_so_far * current_prob;
					if (pointer == WISDOM)
						depth_first_search ((unsigned char) slot + 1, next_slot_available_skills, skills_so_far, magic_schools, true, new_prob_so_far, remaining_weight - skill_chances [ pointer ], probabilities); 	// Hero gains WISDOM.
					else if ((pointer == AIR_MAGIC) || (pointer == EARTH_MAGIC) || (pointer == FIRE_MAGIC) || (pointer == WATER_MAGIC))
						depth_first_search ((unsigned char) slot + 1, next_slot_available_skills, skills_so_far, magic_schools + 1, wisdom, new_prob_so_far, remaining_weight - skill_chances [ pointer ], probabilities); 	// Hero gains one more MAGIC SCHOOL.
					else
						depth_first_search ((unsigned char) slot + 1, next_slot_available_skills, skills_so_far, magic_schools, wisdom, new_prob_so_far, remaining_weight - skill_chances [ pointer ], probabilities); 	// Hero gains neither WISDOM nor any MAGIC SCHOOL.
					skills_so_far [slot] = (unsigned char) NULL_SKILL;
					next_slot_available_skills [pointer] = true;
				}
			}
		}

		delete [] next_slot_available_skills; 	// Free-up memory.
	}
	else {
		/*
		** Final step of recursion.
		*/
		register unsigned char temp_slot;

		for (pointer = 1; pointer < DIFF_SEC_SKILLS; pointer++) {
			if (available_skills [pointer]) {
				// use skill ...
				skills_so_far [slot] = pointer;
				current_prob = (double) ((double) skill_chances [ pointer ]) / ((double) remaining_weight);
				new_prob_so_far = prob_so_far * current_prob;
				for (temp_slot = 0; temp_slot < SKILL_SLOTS; temp_slot++)
					probabilities [ skills_so_far [temp_slot] ] += new_prob_so_far;
				skills_so_far [slot] = NULL_SKILL;
			}
		}
	}

	return;
}

/*****************************************************************************/




/********************************\
*     FUNCTIONS FOR GETTING      *
* SKILL NAMES IN VARIOUS FORMATS *
\********************************/

char * 	get_skill_name_12 (const unsigned char pointer)
{
	char * Skill_Names [DIFF_SEC_SKILLS] = { "NULL SKILL  ", "AIR MAGIC   ", "ARCHERY     ", "ARMORER     ", "ARTILLERY   ", "BALLISTICS  ", "DIPLOMACY   ", "EAGLE EYE   ", "EARTH MAGIC ", "ESTATES     ", "FIRE MAGIC  ", "FIRST AID   ", "INTELLIGENCE", "LEADERSHIP  ", "LEARNING    ", "LOGISTICS   ", "LUCK        ", "MYSTICISM   ", "NAVIGATION  ", "NECROMANCY  ", "OFFENSE     ", "PATHFINDING ", "RESISTANCE  ", "SCHOLAR     ", "SCOUTING    ", "SORCERY     ", "TACTICS     ", "WATER MAGIC ", "WISDOM      " };

	if (pointer >= DIFF_SEC_SKILLS)
		return 	Skill_Names [0];
	else
		return 	Skill_Names [pointer];
}

/*****************************************************************************/

char * 	get_skill_name (const unsigned char pointer)
{
	char * Skill_Names [DIFF_SEC_SKILLS] = { "NULL SKILL", "AIR MAGIC", "ARCHERY", "ARMORER", "ARTILLERY", "BALLISTICS", "DIPLOMACY", "EAGLE EYE", "EARTH MAGIC", "ESTATES", "FIRE MAGIC", "FIRST AID", "INTELLIGENCE", "LEADERSHIP", "LEARNING", "LOGISTICS", "LUCK", "MYSTICISM", "NAVIGATION", "NECROMANCY", "OFFENSE", "PATHFINDING", "RESISTANCE", "SCHOLAR", "SCOUTING", "SORCERY", "TACTICS", "WATER MAGIC", "WISDOM" };

	if (pointer >= DIFF_SEC_SKILLS)
		return 	Skill_Names [0];
	else
		return 	Skill_Names [pointer];
}

/*****************************************************************************/

char * 	get_skill_name_consecutive (const unsigned char pointer)
{
	char * Skill_Names [DIFF_SEC_SKILLS] = { "NULL_SKILL", "AIR_MAGIC", "ARCHERY", "ARMORER", "ARTILLERY", "BALLISTICS", "DIPLOMACY", "EAGLE_EYE", "EARTH_MAGIC", "ESTATES", "FIRE_MAGIC", "FIRST_AID", "INTELLIGENCE", "LEADERSHIP", "LEARNING", "LOGISTICS", "LUCK", "MYSTICISM", "NAVIGATION", "NECROMANCY", "OFFENSE", "PATHFINDING", "RESISTANCE", "SCHOLAR", "SCOUTING", "SORCERY", "TACTICS", "WATER_MAGIC", "WISDOM" };

	if (pointer >= DIFF_SEC_SKILLS)
		return 	Skill_Names [0];
	else
		return 	Skill_Names [pointer];
}

/*****************************************************************************/
